'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _scroll2 = require('./shared/scroll');

var _scroll3 = _interopRequireDefault(_scroll2);

var _utils = require('./lib/utils');

var _Prompt = require('./shared/Prompt');

var _Prompt2 = _interopRequireDefault(_Prompt);

var _pattern_mode_helpers = require('./shared/pattern_mode_helpers');

var _pattern_prompt = require('./shared/pattern_prompt');

var _pattern_prompt2 = _interopRequireDefault(_pattern_prompt);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TestNamePatternPrompt = function (_PatternPrompt) {
  _inherits(TestNamePatternPrompt, _PatternPrompt);

  function TestNamePatternPrompt(pipe, prompt) {
    _classCallCheck(this, TestNamePatternPrompt);

    var _this = _possibleConstructorReturn(this, (TestNamePatternPrompt.__proto__ || Object.getPrototypeOf(TestNamePatternPrompt)).call(this, pipe, prompt));

    _this._entityName = 'tests';
    _this._cachedTestResults = [];
    return _this;
  }

  _createClass(TestNamePatternPrompt, [{
    key: '_onChange',
    value: function _onChange(pattern, options) {
      _get(TestNamePatternPrompt.prototype.__proto__ || Object.getPrototypeOf(TestNamePatternPrompt.prototype), '_onChange', this).call(this, pattern, options);
      this._printTypeahead(pattern, options);
    }
  }, {
    key: '_printTypeahead',
    value: function _printTypeahead(pattern, options) {
      var matchedTests = this._getMatchedTests(pattern);
      var total = matchedTests.length;
      var pipe = this._pipe;
      var prompt = this._prompt;

      (0, _pattern_mode_helpers.printPatternCaret)(pattern, pipe);

      if (pattern) {
        (0, _pattern_mode_helpers.printPatternMatches)(total, 'test', pipe, ` from ${_chalk2.default.yellow('cached')} test suites`);

        var width = (0, _utils.getTerminalWidth)();

        var _scroll = (0, _scroll3.default)(total, options),
            start = _scroll.start,
            end = _scroll.end,
            index = _scroll.index;

        prompt.setTypeaheadLength(total);

        matchedTests.slice(start, end).map(function (name) {
          return (0, _utils.formatTestNameByPattern)(name, pattern, width - 4);
        }).map(function (item, i) {
          return (0, _pattern_mode_helpers.formatTypeaheadSelection)(item, i, index, prompt);
        }).forEach(function (item) {
          return (0, _pattern_mode_helpers.printTypeaheadItem)(item, pipe);
        });

        if (total > end) {
          (0, _pattern_mode_helpers.printMore)('test', pipe, total - end);
        }
      } else {
        (0, _pattern_mode_helpers.printStartTyping)('test name', pipe);
      }

      (0, _pattern_mode_helpers.printRestoredPatternCaret)(pattern, this._currentUsageRows, pipe);
    }
  }, {
    key: '_getMatchedTests',
    value: function _getMatchedTests(pattern) {
      var regex = void 0;

      try {
        regex = new RegExp(pattern, 'i');
      } catch (e) {
        return [];
      }

      var matchedTests = [];

      this._cachedTestResults.forEach(function (_ref) {
        var testResults = _ref.testResults;
        return testResults.forEach(function (_ref2) {
          var title = _ref2.title;

          if (regex.test(title)) {
            matchedTests.push(title);
          }
        });
      });

      return matchedTests;
    }
  }, {
    key: 'updateCachedTestResults',
    value: function updateCachedTestResults() {
      var testResults = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      this._cachedTestResults = testResults;
    }
  }]);

  return TestNamePatternPrompt;
}(_pattern_prompt2.default);

module.exports = TestNamePatternPrompt;