'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _stringLength = require('string-length');

var _stringLength2 = _interopRequireDefault(_stringLength);

var _utils = require('./lib/utils');

var _Prompt = require('./shared/Prompt');

var _Prompt2 = _interopRequireDefault(_Prompt);

var _pattern_mode_helpers = require('./shared/pattern_mode_helpers');

var _scroll2 = require('./shared/scroll');

var _scroll3 = _interopRequireDefault(_scroll2);

var _pattern_prompt = require('./shared/pattern_prompt');

var _pattern_prompt2 = _interopRequireDefault(_pattern_prompt);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TestPathPatternPrompt = function (_PatternPrompt) {
  _inherits(TestPathPatternPrompt, _PatternPrompt);

  function TestPathPatternPrompt(pipe, prompt) {
    _classCallCheck(this, TestPathPatternPrompt);

    var _this = _possibleConstructorReturn(this, (TestPathPatternPrompt.__proto__ || Object.getPrototypeOf(TestPathPatternPrompt)).call(this, pipe, prompt));

    _this._entityName = 'filenames';
    _this._searchSources = [];
    return _this;
  }

  _createClass(TestPathPatternPrompt, [{
    key: '_onChange',
    value: function _onChange(pattern, options) {
      _get(TestPathPatternPrompt.prototype.__proto__ || Object.getPrototypeOf(TestPathPatternPrompt.prototype), '_onChange', this).call(this, pattern, options);
      this._printTypeahead(pattern, options);
    }
  }, {
    key: '_printTypeahead',
    value: function _printTypeahead(pattern, options) {
      var matchedTests = this._getMatchedTests(pattern);
      var total = matchedTests.length;
      var pipe = this._pipe;
      var prompt = this._prompt;

      (0, _pattern_mode_helpers.printPatternCaret)(pattern, pipe);

      if (pattern) {
        (0, _pattern_mode_helpers.printPatternMatches)(total, 'file', pipe);

        var prefix = `  ${_chalk2.default.dim('\u203A')} `;
        var padding = (0, _stringLength2.default)(prefix) + 2;
        var width = (0, _utils.getTerminalWidth)();

        var _scroll = (0, _scroll3.default)(total, options),
            start = _scroll.start,
            end = _scroll.end,
            index = _scroll.index;

        prompt.setTypeaheadLength(total);

        matchedTests.slice(start, end).map(function (_ref) {
          var path = _ref.path,
              context = _ref.context;

          var filePath = (0, _utils.trimAndFormatPath)(padding, context.config, path, width);
          return (0, _utils.highlight)(path, filePath, pattern, context.config.rootDir);
        }).map(function (item, i) {
          return (0, _pattern_mode_helpers.formatTypeaheadSelection)(item, i, index, prompt);
        }).forEach(function (item) {
          return (0, _pattern_mode_helpers.printTypeaheadItem)(item, pipe);
        });

        if (total > end) {
          (0, _pattern_mode_helpers.printMore)('file', pipe, total - end);
        }
      } else {
        (0, _pattern_mode_helpers.printStartTyping)('filename', pipe);
      }

      (0, _pattern_mode_helpers.printRestoredPatternCaret)(pattern, this._currentUsageRows, pipe);
    }
  }, {
    key: '_getMatchedTests',
    value: function _getMatchedTests(pattern) {
      var regex = void 0;

      try {
        regex = new RegExp(pattern, 'i');
      } catch (e) {
        regex = null;
      }

      var tests = [];
      if (regex) {
        this._searchSources.forEach(function (_ref2) {
          var testPaths = _ref2.testPaths,
              config = _ref2.config;

          tests = tests.concat(testPaths.filter(function (testPath) {
            return testPath.match(pattern);
          }).map(function (path) {
            return {
              path,
              context: { config }
            };
          }));
        });
      }

      return tests;
    }
  }, {
    key: 'updateSearchSources',
    value: function updateSearchSources(searchSources) {
      this._searchSources = searchSources;
    }
  }]);

  return TestPathPatternPrompt;
}(_pattern_prompt2.default);

exports.default = TestPathPatternPrompt;